
var algoliasearch = require('algoliasearch');

var client = algoliasearch('FCRL3BY4F4', '5192de33eb3ebc1e29b33923c6a4e68a');
var index = client.initIndex('anuncios');

var schedule = require('node-schedule');

const PRODUCTS='Anuncios'
var serviceAccount = require('./sobreruedas.json');

var admin = require("firebase-admin");
var cron = require('cron');

var serviceAccount = require("./sobreruedas.json");

admin.initializeApp({
    credential: admin.credential.cert(serviceAccount),
    databaseURL: "https://sobreruedas-a1d6a.firebaseio.com"
});

var db = admin.firestore();
var job1 = new cron.CronJob({
    cronTime: '00 00 00 * *',
    onTick: function() {
        console.log('job 1 ticked');
        sincro();
    },
    start: true,
    timeZone: 'Europe/Madrid'
});

console.log('job1 status', job1.running); // job1 status undefined

const today = new Date();
const date =new Date();
date.setDate(today.getDate()-60);

function sincro() {


    var x = db.collection(PRODUCTS)
        .where("activo", "==", true)
        .where("fecha_renovacion","<", date)
        .get()
        .then(function (querySnapshot) {
            querySnapshot.forEach(function (doc) {
                console.log('Anuncios caducados: ' + doc.id);
                return doc.ref.update({
                    activo: false
                })
                    .then(function () {
                        console.log("Document successfully updated!");
                        var object = {
                            activo: false,
                            objectID: doc.id
                        };
                        index.partialUpdateObject(object, false, null);

                        const payLoad = {
                            notification: {
                                title: 'El anuncio ' + doc.data().title + ' ha caducado',
                                body: 'Puede renovar el anuncio desde la app',
                            },
                            data: {
                                type: 'Caducity',
                                anuncioId: doc.data().id
                            }
                        };
                        const options = {
                            priority: "high",
                            timeToLive: 60 * 60 * 2
                        };
                        admin.messaging().sendToTopic(doc.data().id_usuario, payLoad, options)
                            .then(function (response) {
                                console.log("Successfully sended message to topic: " + doc.data().id_usuario);
                            })
                            .catch(function (error) {
                                console.log("Error sending message to topic: ", +doc.data().id_usuario, error);
                            });
                    })
                    .catch(function (error) {
                        // The document probably doesn't exist.
                        console.error("Error updating document: ", error);
                    });
            });
        })
        .catch(function (error) {
            console.log("Error getting documents: ", error);
        });

}