package com.example.xavierferraronsserra.sobreruedas.Adapters;

        import com.example.xavierferraronsserra.sobreruedas.Model.Anuncio;

import java.util.List;
import android.content.Context;
        import android.support.annotation.NonNull;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

        import com.example.xavierferraronsserra.sobreruedas.Model.Agrupation;
        import com.example.xavierferraronsserra.sobreruedas.R;
import com.example.xavierferraronsserra.sobreruedas.Utils.StorageManagement;
import com.example.xavierferraronsserra.sobreruedas.Utils.Utils;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.firestore.DocumentSnapshot;
        import com.makeramen.roundedimageview.RoundedTransformationBuilder;
        import com.squareup.picasso.Picasso;
import com.squareup.picasso.Transformation;

        import butterknife.BindView;
import butterknife.ButterKnife;


/**
 * Created by xavierferraronsserra on 12/4/18.
 */

public class AnunciosAdapter extends RecyclerView.Adapter<AnunciosAdapter.AnunciosHolder> {

    private List<Anuncio> mAnuncios;
    public Context mContext;
    public final String TAG="AnunciosAdapter";
    private AnunciosHolder.ClickListener mClickListener;


    public AnunciosAdapter(Context context, List<Anuncio> anuncios, AnunciosHolder.ClickListener clickListener) {

        mAnuncios= anuncios;
        mContext= context;
        mClickListener=clickListener;
    }

    @Override
    public AnunciosHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        LayoutInflater inflater = LayoutInflater.from(parent.getContext());
        return new AnunciosHolder(inflater.inflate(R.layout.list_item_anuncio,parent,false),mClickListener);
    }

    @Override
    public void onBindViewHolder(AnunciosHolder holder, int position) {
        holder.bind(mContext,mAnuncios.get(position));
    }

    @Override
    public int getItemCount() {
        return mAnuncios.size();
    }

    public static class AnunciosHolder extends RecyclerView.ViewHolder implements View.OnClickListener {
        public final String TAG="AnunciosHolder";
        private Anuncio mAnuncio;
        private Context mContext;
        private ClickListener mClickListener;


        @BindView(R.id.list_item_anuncio_image) ImageView mImageView;
        @BindView(R.id.list_item_anuncio_title)  TextView mTextViewTitle;
        @BindView(R.id.list_item_anuncio_price)  TextView mTextViewPrice;
        @BindView(R.id.list_item_anuncio_agrupation)  TextView mTextViewAgrupation;
        @BindView(R.id.list_item_anuncio_date)  TextView mTextViewDate;
        @BindView(R.id.list_item_anuncio_address)  TextView mTextViewAddress;


        public AnunciosHolder(View itemView, ClickListener clickListener) {
            super(itemView);
            mClickListener=clickListener;
            ButterKnife.bind(this, itemView);
            itemView.setOnClickListener(this);
        }

        public void bind(Context context, Anuncio anuncio){
            mAnuncio = anuncio;
            mContext = context;

            StorageManagement.getAgrupationById(mAnuncio.getAgrupacion()).get()
                    .addOnCompleteListener(new OnCompleteListener<DocumentSnapshot>() {
                @Override
                public void onComplete(@NonNull Task<DocumentSnapshot> task) {
                    if (task.isSuccessful()) {
                        Log.d(TAG, "getAgrupationById:ok");
                        Agrupation agrupation=task.getResult().toObject(Agrupation.class);
                        mTextViewAgrupation.setText(agrupation.getDescripcion());
                        mTextViewTitle.setText(mAnuncio.getTitle());
                        mTextViewPrice.setText(Utils.formatPrice(mAnuncio.getPrice()));
                        mTextViewDate.setText(Utils.formatDate(mAnuncio.getFecha_alta()));
                        mTextViewAddress.setText(mAnuncio.getAddress());

                    } else {
                        Log.e(TAG, "getAgrupationById:error: " + task.getException().toString());
                    }
                }
            });

            Transformation transformation = new RoundedTransformationBuilder()
                    .cornerRadiusDp(40)
                    .oval(false)
                    .build();
            if(mAnuncio.getFotos().size()!=0) {
                Picasso.get().load(mAnuncio.getFotoByPosition(String.valueOf(0)).getUrl()).fit().centerCrop().placeholder(R.drawable.progress_animation).error(R.drawable.ic_error).noFade().into(mImageView);
            }
        }

        @Override
        public void onClick(View v) {
            if(mClickListener!=null){
                mClickListener.onItemClicked(mAnuncio);
            }

        }

        public interface ClickListener {

            public void onItemClicked(Anuncio anuncio);
        }
    }
}
