package com.example.xavierferraronsserra.sobreruedas.Adapters;

import android.content.Context;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.SwitchCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.example.xavierferraronsserra.sobreruedas.Model.Agrupation;
import com.example.xavierferraronsserra.sobreruedas.R;
import com.example.xavierferraronsserra.sobreruedas.Utils.StorageManagement;
import com.google.firebase.auth.FirebaseAuth;

import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * Created by xavierferraronsserra on 17/4/18.
 */

public class NotificacionesAdapter extends  RecyclerView.Adapter<NotificacionesAdapter.NotificacionesHolder>{

    private List<Agrupation> mNotifications;
    private Context mContext;

    public NotificacionesAdapter(Context context, List<Agrupation> notifications){
        mNotifications=notifications;
        mContext = context;
    }

    @Override
    public NotificacionesHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        LayoutInflater layoutInflater = LayoutInflater.from(mContext);
        return new NotificacionesHolder(mContext, layoutInflater, parent);
    }

    @Override
    public void onBindViewHolder(NotificacionesHolder holder, int position) {
        Agrupation notification = mNotifications.get(position);
        holder.bind(notification);
    }

    @Override
    public int getItemCount() {
        return mNotifications.size();
    }


    static class NotificacionesHolder extends RecyclerView.ViewHolder {
        private Agrupation mNotification;

        @BindView(R.id.list_notificaciones_description) TextView mTextViewDescription;
        @BindView(R.id.list_notificaciones_switch) SwitchCompat mSwitchCompatSwitch;

        public NotificacionesHolder(final Context context, LayoutInflater inflater, ViewGroup parent) {
            super(inflater.inflate(R.layout.list_item_notificacion, parent, false));
            ButterKnife.bind(this,itemView);
            mSwitchCompatSwitch.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    StorageManagement.setUserNotification(context,FirebaseAuth.getInstance().getCurrentUser().getUid(),mNotification.getId(), mSwitchCompatSwitch.isChecked());
                }
            });
        }



        public void bind(Agrupation notificacion){

            mNotification=notificacion;

            mTextViewDescription.setText(mNotification.getDescripcion());
            mSwitchCompatSwitch.setChecked(mNotification.isActive());
        }
    }
}
