package com.example.xavierferraronsserra.sobreruedas.Adapters;

import android.content.Context;
import android.os.Parcelable;
import android.support.v4.view.PagerAdapter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;

import com.example.xavierferraronsserra.sobreruedas.Model.Anuncio;
import com.example.xavierferraronsserra.sobreruedas.R;
import com.squareup.picasso.Callback;
import com.squareup.picasso.Picasso;

/**
 * Created by xavierferraronsserra on 14/4/18.
 */

public class SlidingImageAdapter extends PagerAdapter {
    private Anuncio mAnuncio;
    private LayoutInflater mInflater;
    private Context mContext;


    public SlidingImageAdapter(Context context,Anuncio anuncio) {
        this.mContext = context;
        this.mAnuncio =anuncio;
        mInflater = LayoutInflater.from(context);
    }

    @Override
    public void destroyItem(ViewGroup container, int position, Object object) {
        container.removeView((View) object);
    }

    @Override
    public int getCount() {
        return mAnuncio.getFotos().size();
    }

    @Override
    public Object instantiateItem(ViewGroup view, int position) {
        final View imageLayout = mInflater.inflate(R.layout.sliding_images, view, false);

        assert imageLayout != null;
        final ImageView imageView = (ImageView) imageLayout
                .findViewById(R.id.sliding_images_image);

        Picasso.get().load(mAnuncio.getFotoByPosition(String.valueOf(position)).getUrl()).fit().centerCrop().placeholder(R.drawable.progress_animation).error(R.drawable.ic_error).noFade().into(imageView);

        view.addView(imageLayout, 0);

        return imageLayout;
    }

    @Override
    public boolean isViewFromObject(View view, Object object) {
        return view.equals(object);
    }

    @Override
    public void restoreState(Parcelable state, ClassLoader loader) {
    }

    @Override
    public Parcelable saveState() {
        return null;
    }

}
