package com.example.xavierferraronsserra.sobreruedas;

import android.*;
import android.Manifest;
import android.app.Activity;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.BitmapDrawable;
import android.net.Uri;
import android.os.Bundle;
import android.provider.MediaStore;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.design.widget.TextInputEditText;
import android.support.design.widget.TextInputLayout;
import android.support.v4.app.Fragment;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AlertDialog;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.view.inputmethod.InputMethodManager;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.Spinner;
import android.widget.Toast;

import com.algolia.search.saas.AlgoliaException;
import com.example.xavierferraronsserra.sobreruedas.Model.Agrupation;
import com.example.xavierferraronsserra.sobreruedas.Model.Anuncio;
import com.example.xavierferraronsserra.sobreruedas.Model.Foto;
import com.example.xavierferraronsserra.sobreruedas.Model.Usuario;
import com.example.xavierferraronsserra.sobreruedas.Utils.StorageManagement;
import com.example.xavierferraronsserra.sobreruedas.Utils.Utils;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.firestore.DocumentSnapshot;
import com.google.firebase.firestore.QuerySnapshot;
import com.google.firebase.storage.UploadTask;
import com.squareup.picasso.Picasso;

import org.json.JSONObject;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.UUID;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

import static android.app.Activity.RESULT_OK;

/**
 * Created by xavierferraronsserra on 9/4/18.
 */

public class AltaAnuncioFragment extends Fragment {

    public static final String ARG_ANUNCIO="com.example.xavierferraronsserra.sobreruedas.anuncio";
    public static final String EXTRA_ANUNCIO = "com.example.xavierferraronsserra.sobreruedas.alta_anuncio";
    private final int REQUEST_READ_EXTERNAL_STORAGE = 1;



    @BindView(R.id.new_product_agrupations) Spinner mAgrupationsSpinner;
    @BindView(R.id.i_new_product_title) TextInputEditText inputTitleEditText;
    @BindView(R.id.il_new_product_title)TextInputLayout inputLayoutTitle;
    @BindView(R.id.i_new_product_price) TextInputEditText inputPriceEditText;
    @BindView(R.id.il_new_product_price)TextInputLayout inputLayoutPrice;
    @BindView(R.id.i_new_product_description) TextInputEditText inputDescriptionEditText;
    @BindView(R.id.il_new_product_description)TextInputLayout inputLayoutDescription;
    @BindView(R.id.new_product_image1) ImageView mImageView1;
    @BindView(R.id.new_product_close1) ImageView mCloseImageView1;
    @BindView(R.id.new_product_image2) ImageView mImageView2;
    @BindView(R.id.new_product_close2) ImageView mCloseImageView2;
    @BindView(R.id.new_product_image3) ImageView mImageView3;
    @BindView(R.id.new_product_close3) ImageView mCloseImageView3;
    @BindView(R.id.new_product_image4) ImageView mImageView4;
    @BindView(R.id.new_product_close4) ImageView mCloseImageView4;
    @BindView(R.id.alta_anuncio_progress_bar)
    ProgressBar mProgressBar;

    private View mView;


    private final String TAG="AltaAnuncioFragment";
    private List<Agrupation> mAgrupationList;
    private boolean mValidate;
    private int[] mDeletedImages= new int [4];
    private int[] mAtachedImages= new int [4];
    private int[] mNewImages= new int [4];

    private int mUploadedImages;
    private int mTotalImages;
    private int mProcessedImages;
    private List<Foto> mFotos= new ArrayList<>();
    private Anuncio mAnuncio;

    private static int THUMBNAIL_SIZE=1000;
    private final int CAMERA_REQUEST=10;
    private final int GALLERY_REQUEST=100;

    private boolean editMode;

    private FirebaseAuth mAuth;

    public static AltaAnuncioFragment newInstance(Anuncio anuncio){
        Bundle args = new Bundle();
        args.putParcelable(ARG_ANUNCIO, anuncio);
        AltaAnuncioFragment altaAnuncioFragment = new AltaAnuncioFragment();
        altaAnuncioFragment.setArguments(args);
        return altaAnuncioFragment;
    }

    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setHasOptionsMenu(true);
        mAuth=FirebaseAuth.getInstance();
        mAnuncio =new Anuncio();
        if(getArguments()!=null){
            mAnuncio=getArguments().getParcelable(ARG_ANUNCIO);
            editMode=true;
        }
        else{
            editMode=false;
        }

        if(!editMode) {
            mAnuncio.setId(UUID.randomUUID().toString());
        }
        getExternalStoragePermission();
    }

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        final View view = inflater.inflate(R.layout.fragment_alta_anuncio, container,false);
        ButterKnife.bind(this, view);
        mView = view;

        // Hide keyboard when touch on screen
        view.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {
                hideSoftKeyboard(view, getActivity());
                return true;
            }
        });

        mProgressBar.setVisibility(View.VISIBLE);
        getActivity().getWindow().setFlags(WindowManager.LayoutParams.FLAG_NOT_TOUCHABLE, WindowManager.LayoutParams.FLAG_NOT_TOUCHABLE);
        mImageView1.setTag("0");
        mImageView2.setTag("1");
        mImageView3.setTag("2");
        mImageView4.setTag("3");

        mCloseImageView1.setVisibility(View.GONE);
        mCloseImageView2.setVisibility(View.GONE);
        mCloseImageView3.setVisibility(View.GONE);
        mCloseImageView4.setVisibility(View.GONE);

        if(editMode){
            setFormData();
        }

        StorageManagement.getAgrupations(getContext())
                .get()
                .addOnCompleteListener(new OnCompleteListener<QuerySnapshot>() {
                    @Override
                    public void onComplete(@NonNull Task<QuerySnapshot> task) {
                        if (task.isSuccessful()) {
                            mAgrupationList=new ArrayList<>();
                            mAgrupationList.add(new Agrupation("0", "Seleccione una agrupación"));
                            for (DocumentSnapshot document : task.getResult()) {
                                Log.d(TAG, document.getId() + " => "+ document.toObject(Agrupation.class).toString());
                                Agrupation agrupation = document.toObject(Agrupation.class);
                                agrupation.setId(document.getId());
                                mAgrupationList.add(agrupation);
                            }
                            ArrayAdapter<CharSequence> adapter = new ArrayAdapter(getActivity(),R.layout.spinner_item, mAgrupationList);
                            adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
                            mAgrupationsSpinner.setAdapter(adapter);
                            if(editMode){
                                for(int i=0; i<mAgrupationList.size();i++){
                                    if(mAgrupationList.get(i).getId().equals(mAnuncio.getAgrupacion())){
                                        mAgrupationsSpinner.setSelection(i);
                                        break;
                                    }
                                }
                            }
                            mProgressBar.setVisibility(View.GONE);
                            getActivity().getWindow().clearFlags(WindowManager.LayoutParams.FLAG_NOT_TOUCHABLE);
                        }
                        else {
                            Log.d(TAG, "Error getting documents: ", task.getException());
                        }
                    }
                });

        setOnFocusChange();

        return  view;
    }

    public void setOnFocusChange() {

        inputTitleEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if (!hasFocus) {
                    validateText(inputLayoutTitle, inputTitleEditText);
                }
            }
        });
        inputDescriptionEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if (!hasFocus) {
                    validateText(inputLayoutDescription, inputDescriptionEditText);
                }
            }
        });
        inputPriceEditText.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if(!hasFocus){
                    validateNotNull(inputLayoutPrice,inputPriceEditText);
                }
            }
        });
    }

    @Override
    public void onCreateOptionsMenu(Menu menu, MenuInflater inflater) {
        super.onCreateOptionsMenu(menu, inflater);
        inflater.inflate(R.menu.menu_save,menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.menu_save:
                validate();
                if(mValidate){
                    mProgressBar.setVisibility(View.VISIBLE);
                    getActivity().getWindow().setFlags(WindowManager.LayoutParams.FLAG_NOT_TOUCHABLE, WindowManager.LayoutParams.FLAG_NOT_TOUCHABLE);
                    createAnuncio();
                }
                return true;

            default:
                return super.onOptionsItemSelected(item);
        }
    }



    private void createAnuncio(){
        StorageManagement.getUser(getContext(),mAuth.getCurrentUser().getUid())
                .get().addOnCompleteListener(new OnCompleteListener<DocumentSnapshot>() {
            @Override
            public void onComplete(@NonNull final Task<DocumentSnapshot> task) {
                if (task.isSuccessful()) {
                    DocumentSnapshot document = task.getResult();
                    if (document != null) {
                        Usuario usuario= document.toObject(Usuario.class);
                        setAnuncioData(usuario);
                        boolean imagesChanged=false;
                        for(int i=0;i<4;i++){
                            if(mDeletedImages[i]==1){
                                mProcessedImages++;
                                deleteImageFromStorage(i);
                                imagesChanged=true;
                            }
                            if(mNewImages[i]==1){
                                mProcessedImages++;
                                ImageView image=getImageById(i);
                                saveImageToStorage(image);
                                imagesChanged=true;
                            }
                        }
                        if(!imagesChanged){
                            saveAnuncio();
                        }

                        Log.d(TAG, "DocumentSnapshot data: " + task.getResult().getData());
                    } else {
                        Log.d(TAG, "No such document");
                    }
                } else {
                    Log.d(TAG, "get failed with ", task.getException());
                }
            }
        });
    }

    private void deleteImageFromStorage(final int i){
        StorageManagement.deleteImage(mAnuncio.getId(),Integer.toString(i)).addOnCompleteListener(new OnCompleteListener() {
            @Override
            public void onComplete(@NonNull Task task) {
                if(task.isSuccessful()){
                    Log.d(TAG, "Deleted image from storage");
                    mAnuncio.getFotos().remove(mAnuncio.getFotoByPosition(String.valueOf(i)));
                    mUploadedImages++;
                    if (mUploadedImages == mProcessedImages) {
                        saveAnuncio();
                    }
                }
                else{
                    Log.d(TAG, "Failed deleting image from storage", task.getException());
                }
            }
        });
    }


    private void setAnuncioData(Usuario usuario){

        mAnuncio.setId_usuario(mAuth.getCurrentUser().getUid());
        mAnuncio.setActivo(true);
        mAnuncio.setAgrupacion(((Agrupation) mAgrupationsSpinner.getSelectedItem()).getId());
        mAnuncio.setPosicion(usuario.getPosicion());
        mAnuncio.setTitle(inputTitleEditText.getText().toString());
        mAnuncio.setPrice(Integer.parseInt(inputPriceEditText.getText().toString()));
        mAnuncio.setDescripcion(inputDescriptionEditText.getText().toString());
        mAnuncio.setAddress(usuario.getDireccion());
        if(!editMode){
            mAnuncio.setFecha_alta(new Date());
            mAnuncio.setFecha_renovacion(new Date());
        }
    }

    private void setFormData(){
        inputTitleEditText.setText(mAnuncio.getTitle());
        inputDescriptionEditText.setText(mAnuncio.getDescripcion());
        inputPriceEditText.setText(Integer.toString((int)mAnuncio.getPrice()));
        List<Foto> fotos = mAnuncio.getFotos();
        for(int i=0; i<fotos.size();i++){
            mAtachedImages[i]=1;
            Foto foto = fotos.get(i);
            final ImageView imageView=getImageById(foto.getPosition());
            imageView.setBackground(null);
            getImageClearById(i).setVisibility(View.VISIBLE);
            Picasso.get().load(foto.getUrl()).fit().centerCrop().placeholder(R.drawable.progress_animation).error(R.drawable.ic_error).noFade().into(imageView);
        }
    }

    private void saveImageToStorage(final ImageView imageView) {
        final int position=Integer.parseInt(imageView.getTag().toString());
        if (imageView.getDrawable() instanceof BitmapDrawable && (mNewImages[position]==1 )) {
            Bitmap bitmap = ((BitmapDrawable) imageView.getDrawable()).getBitmap();
            StorageManagement.newImage(mAnuncio.getId(), imageView.getTag().toString(), bitmap, mAtachedImages[position])
                    .addOnCompleteListener(new OnCompleteListener<UploadTask.TaskSnapshot>() {
                        @Override
                        public void onComplete(@NonNull Task<UploadTask.TaskSnapshot> task) {
                            if (task.isSuccessful()) {
                                mUploadedImages++;
                                Foto foto=mAnuncio.getFotoByPosition(imageView.getTag().toString());
                                if(foto!=null){
                                    mAnuncio.getFotos().remove(foto);
                                }
                                mAnuncio.addFoto(new Foto(task.getResult().getDownloadUrl().toString(), Utils.tryParseInt(imageView.getTag().toString())));
                                if (mUploadedImages == mProcessedImages) {
                                    saveAnuncio();
                                }
                            }
                        }
                    });
        }

    }

    private void saveAnuncio(){
        StorageManagement.newAnuncio(mAnuncio)
                .addOnCompleteListener(new OnCompleteListener<Void>() {
                    @Override
                    public void onComplete(@NonNull Task<Void> task) {
                        if (task.isSuccessful()) {
                            Log.d(TAG, "Successfully added Product");
                            com.algolia.search.saas.CompletionHandler handler =new com.algolia.search.saas.CompletionHandler() {
                                @Override
                                public void requestCompleted(JSONObject jsonObject, AlgoliaException e) {
                                    if(jsonObject!=null){
                                        Log.d(TAG, "Successfully added Product at Algolia");
                                        StorageManagement.getIndex().getObjectAsync(mAnuncio.getId(),null);
                                        mProgressBar.setVisibility(View.GONE);
                                        getActivity().getWindow().clearFlags(WindowManager.LayoutParams.FLAG_NOT_TOUCHABLE);
                                        sendListadoAnuncios();
                                    }
                                    else{
                                        Log.d(TAG, "Error adding Product at Algolia");
                                        mProgressBar.setVisibility(View.GONE);
                                        getActivity().getWindow().clearFlags(WindowManager.LayoutParams.FLAG_NOT_TOUCHABLE);
                                        saveErrorMessage();
                                    }
                                }
                            };
                            StorageManagement.getIndex().saveObjectAsync(Utils.ObjectToJsonAnuncio(mAnuncio), mAnuncio.getId(),handler);

                        } else {
                            Log.w(TAG, "Error adding Product", task.getException());
                            mProgressBar.setVisibility(View.GONE);
                            getActivity().getWindow().clearFlags(WindowManager.LayoutParams.FLAG_NOT_TOUCHABLE);
                            saveErrorMessage();

                        }
                    }
                });
    }

    private void saveErrorMessage(){
        Toast.makeText(getContext(),getResources().getString(R.string.save_product_error), Toast.LENGTH_SHORT).show();
    }

    private boolean validate(){
        mValidate=true;
        validateText(inputLayoutTitle, inputTitleEditText);
        validateText(inputLayoutDescription, inputDescriptionEditText);
        validateNotNull(inputLayoutPrice,inputPriceEditText);
        validateAgrupation();
        validateMainPhoto();
        validateOrderPhoto();

        return mValidate;
    }


    private void sendListadoAnuncios() {
        if(editMode){
            Intent i = new Intent(getContext(), ListadoAnunciosUsuarioActivity.class);
            startActivity(i);
        }
        else {
            Intent i = new Intent();
            i.putExtra(EXTRA_ANUNCIO, mAnuncio);
            getActivity().setResult(Activity.RESULT_OK, i);
            getActivity().finish();
        }
    }


    @OnClick({R.id.new_product_image1, R.id.new_product_image2, R.id.new_product_image3, R.id.new_product_image4})
    public void addNewImage(final ImageView image){
        final int i = getImageId(image);

        if (mAtachedImages[i]==1 || mNewImages[i]==1){
            image.setImageDrawable(getResources().getDrawable(R.drawable.ic_photo_camera));
            image.setScaleType(ImageView.ScaleType.CENTER);
            ImageView imageViewClose =getImageClearById(i);
            imageViewClose.setVisibility(View.GONE);
            image.setBackground(getResources().getDrawable(R.drawable.back_photo));
            mAtachedImages[i]=0;
            mNewImages[i]=0;
            mDeletedImages[i]=1;
        }
        else{
            final CharSequence[] options = {getResources().getString(R.string.camera), getResources().getString(R.string.gallery)};
            AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
            builder.setTitle(getResources().getString(R.string.new_product_select_image));
            builder.setItems(options, new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int item) {
                    dialog.dismiss();
                    if(options[item].equals(getResources().getString(R.string.camera))) {
                        Intent galleryIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
                        if (galleryIntent.resolveActivity(getActivity().getPackageManager()) != null) {
                            startActivityForResult(galleryIntent, i + CAMERA_REQUEST);
                        }
                    } else if (options[item].equals(getResources().getString(R.string.gallery))) {
                        Intent cameraIntent = new Intent(Intent.ACTION_PICK, MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
                        if (cameraIntent.resolveActivity(getActivity().getPackageManager()) != null) {
                            startActivityForResult(cameraIntent, i + GALLERY_REQUEST);
                        }
                    }
                }
            });
            builder.show();
        }
    }

    private int getImageId(ImageView image) {
        int i=1;
        switch (image.getId()) {
            case R.id.new_product_image1:
                i = 0;
                break;
            case R.id.new_product_image2:
                i = 1;
                break;
            case R.id.new_product_image3:
                i = 2;
                break;
            case R.id.new_product_image4:
                i = 3;
                break;
        }
        return i;
    }

    private ImageView getImageById(int imageId) {

        ImageView imageView;

        switch (imageId) {
            case 0:
                imageView=mImageView1;
                break;
            case 1:
                imageView=mImageView2;
                break;
            case 2:
                imageView=mImageView3;
                break;
            case 3:
                imageView=mImageView4;
                break;
            default:
                imageView=mImageView1;
        }
        return imageView;
    }

    private ImageView getImageClearById(int imageId) {

        ImageView imageView;

        switch (imageId) {
            case 0:
                imageView=mCloseImageView1;
                break;
            case 1:
                imageView=mCloseImageView2;
                break;
            case 2:
                imageView=mCloseImageView3;
                break;
            case 3:
                imageView=mCloseImageView4;
                break;
            default:
                imageView=mCloseImageView1;
        }
        return imageView;
    }


    private void setSelectedImage(int imageId, Bitmap bitmap) {

        ImageView image=getImageById(imageId);
        image.setImageBitmap(bitmap);
        image.setScaleType(ImageView.ScaleType.CENTER_CROP);
        image.setBackground(null);
        getImageClearById(imageId).setVisibility(View.VISIBLE);
    }

    private   Bitmap getThumbnail(Uri uri) throws FileNotFoundException, IOException{

        InputStream input =  getActivity().getContentResolver().openInputStream(uri);

        BitmapFactory.Options onlyBoundsOptions = new BitmapFactory.Options();

        onlyBoundsOptions.inJustDecodeBounds = true;
        onlyBoundsOptions.inDither=true;//optional
        onlyBoundsOptions.inPreferredConfig=Bitmap.Config.ARGB_8888;//optional

        BitmapFactory.decodeStream(input, null, onlyBoundsOptions);

        input.close();

        if ((onlyBoundsOptions.outWidth == -1) || (onlyBoundsOptions.outHeight == -1)) {
            return null;
        }

        int originalSize = (onlyBoundsOptions.outHeight > onlyBoundsOptions.outWidth) ? onlyBoundsOptions.outHeight : onlyBoundsOptions.outWidth;

        double ratio = (originalSize > THUMBNAIL_SIZE) ? (originalSize / THUMBNAIL_SIZE) : 1.0;

        BitmapFactory.Options bitmapOptions = new BitmapFactory.Options();

        bitmapOptions.inSampleSize = getPowerOfTwoForSampleRatio(ratio);
        bitmapOptions.inDither = true; //optional
        bitmapOptions.inPreferredConfig=Bitmap.Config.ARGB_8888;//

        input = getActivity().getContentResolver().openInputStream(uri);

        Bitmap bitmap = BitmapFactory.decodeStream(input, null, bitmapOptions);

        input.close();

        return bitmap;
    }

    private static int getPowerOfTwoForSampleRatio(double ratio){
        int k = Integer.highestOneBit((int)Math.floor(ratio));
        if(k==0) return 1;
        else return k;
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (resultCode != RESULT_OK) {
            return;
        }
        int imageId=0;
        Bitmap bitmap = null;

        if (requestCode >= GALLERY_REQUEST) {
            imageId = requestCode - GALLERY_REQUEST;
            mNewImages[imageId]=1;
            mDeletedImages[imageId]=0;

            Uri selectedImage = data.getData();
            try {
                bitmap=getThumbnail(selectedImage);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        else {
            imageId = requestCode - CAMERA_REQUEST;
            mNewImages[imageId]=1;
            mDeletedImages[imageId]=0;
            Bundle extras = data.getExtras();
            bitmap = (Bitmap) extras.get("data");
        }

        setSelectedImage(imageId,  bitmap);

    }

    public static void hideSoftKeyboard(View view, Activity activity) {
        InputMethodManager in = (InputMethodManager) activity.getSystemService(Context.INPUT_METHOD_SERVICE);
        in.hideSoftInputFromWindow(view.getWindowToken(), InputMethodManager.HIDE_NOT_ALWAYS);
    }

    private void validateLengthText(TextInputLayout textInputLayout,TextInputEditText textInputEditText){
        boolean haveErrors;
        if(textInputLayout.getError().equals("")){
            haveErrors=false;
        }
        else{
            haveErrors=true;
        }

        if(textInputEditText.length()>textInputLayout.getCounterMaxLength()){
            mValidate=false;
            textInputLayout.setError(getResources().getString(R.string.validation_length,textInputLayout.getCounterMaxLength()));
        }
        else{
            if(!haveErrors)
                textInputLayout.setError("");
        }
    }

    private void validateAgrupation(){
        if(mAgrupationsSpinner.getSelectedItemPosition()==0){
            Toast.makeText(getContext(),R.string.validation_agrupation,Toast.LENGTH_SHORT).show();
            mValidate=false;
        }
    }

    private void validateMainPhoto() {
        if (!(mAtachedImages[0] == 1 || mNewImages[0] == 1)) {
            Toast.makeText(getContext(),R.string.validation_main_photo,Toast.LENGTH_SHORT).show();
            mValidate=false;
        }
    }

    private void validateOrderPhoto(){
        for (int i=0;i<3;i++){
            if(((mAtachedImages[i+1]==1 || mNewImages[i+1]==1) &&  (mAtachedImages[i]==0 && mNewImages[i]==0))){
                Toast.makeText(getContext(),R.string.validation_photo_order,Toast.LENGTH_SHORT).show();
                mValidate=false;
                break;
            }
        }
    }

    private  void validateNotNull(TextInputLayout inputLayout, TextInputEditText text) {
        if (text.getText().toString().isEmpty()) {
            mValidate = false;
            inputLayout.setError( getResources().getString(R.string.validation_required));
        }
        else{
            inputLayout.setError("");
        }
    }

    private void validateText(TextInputLayout inputLayout, TextInputEditText text){
        validateNotNull(inputLayout,text);
        validateLengthText(inputLayout, text);

    }

    private void getExternalStoragePermission() {
        if (ContextCompat.checkSelfPermission(getContext(),
                Manifest.permission.READ_EXTERNAL_STORAGE)
                == PackageManager.PERMISSION_GRANTED) {
        } else {
            if (shouldShowRequestPermissionRationale(Manifest.permission.READ_EXTERNAL_STORAGE)) {
                showMessageOKCancel(getResources().getString(R.string.validation_storage),
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                requestPermissions(new String[]{Manifest.permission.READ_EXTERNAL_STORAGE}, REQUEST_READ_EXTERNAL_STORAGE);
                            }
                        });
                return;
            }
            else {
                requestPermissions(new String[]{Manifest.permission.READ_EXTERNAL_STORAGE}, REQUEST_READ_EXTERNAL_STORAGE);
                return;
            }
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, String[] permissions, int[] grantResults) {
        switch (requestCode) {
            case REQUEST_READ_EXTERNAL_STORAGE:
                // If request is cancelled, the result arrays are empty.
                if (grantResults.length > 0
                        && grantResults[0] == PackageManager.PERMISSION_GRANTED) {

                }
                break;
            default:
                super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        }
    }

    private void showMessageOKCancel(String message, DialogInterface.OnClickListener okListener) {
        new AlertDialog.Builder(getActivity())
                .setMessage(message)
                .setPositiveButton("OK", okListener)
                .setNegativeButton("Cancel", null)
                .create()
                .show();
    }

}
