package com.example.xavierferraronsserra.sobreruedas;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.widget.Toolbar;

import com.example.xavierferraronsserra.sobreruedas.Model.Anuncio;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * Created by xavierferraronsserra on 9/4/18.
 */

public class AltaAnuncioUsuarioActivity extends SingleFragmentActivity {


    @BindView(R.id.toolbar)
    Toolbar mToolbar;
    Anuncio mAnuncio;


    public static final String EXTRA_ANUNCIO = "com.example.xavierferraronsserra.sobreruedas.anuncio_alta";


    public static Intent newIntent(Context packageContext, Anuncio anuncio) {
        Intent intent = new Intent(packageContext, AltaAnuncioUsuarioActivity.class);
        intent.putExtra(EXTRA_ANUNCIO, anuncio);
        return intent;
    }

    @Override
    protected Fragment createFragment() {
        mAnuncio =getIntent().getExtras().getParcelable(EXTRA_ANUNCIO);
        return AltaAnuncioFragment.newInstance(mAnuncio);
    }


    @Override
    protected int getLayoutResId() {
        return R.layout.activity_menu_fragment;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        mAnuncio=getIntent().getParcelableExtra(EXTRA_ANUNCIO);

        ButterKnife.bind(this);

        setSupportActionBar(mToolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setTitle(mAnuncio.getTitle());

    }
}
