package com.example.xavierferraronsserra.sobreruedas.Model;

import android.os.Parcel;
import android.os.Parcelable;

import com.google.firebase.firestore.GeoPoint;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * Created by xavierferraronsserra on 11/4/18.
 */

public class Anuncio implements Parcelable {

    private String id;
    private String id_usuario;
    private Date fecha_alta;
    private Date fecha_renovacion;
    private boolean activo;
    private String agrupacion;
    private GeoPoint posicion;
    private String title;
    private float price;
    private String descripcion;
    private int visitas=1;
    private String address;
    private List<Foto> fotos = new ArrayList<>();

    public Anuncio(){

    }

    public Anuncio(String id, String id_usuario, Date fecha_alta, Date fecha_renovacion, boolean activo, String agrupacion, GeoPoint posicion, String title, float price, String descripcion, int visitas, String address, List<Foto> fotos) {
        this.id=id;
        this.id_usuario = id_usuario;
        this.fecha_alta = fecha_alta;
        this.fecha_renovacion = fecha_renovacion;
        this.activo = activo;
        this.agrupacion = agrupacion;
        this.posicion = posicion;
        this.title = title;
        this.price = price;
        this.descripcion = descripcion;
        this.visitas = visitas;
        this.address = address;
        this.fotos = fotos;
    }

    public Anuncio(String id_usuario, Date fecha_alta, Date fecha_renovacion, boolean activo, String agrupacion, GeoPoint posicion, String title, float price, String descripcion, int visitas, String address, List<Foto> fotos) {
        this.id_usuario = id_usuario;
        this.fecha_alta = fecha_alta;
        this.fecha_renovacion = fecha_renovacion;
        this.activo = activo;
        this.agrupacion = agrupacion;
        this.posicion = posicion;
        this.title = title;
        this.price = price;
        this.descripcion = descripcion;
        this.visitas = visitas;
        this.address = address;
        this.fotos = fotos;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getId_usuario() {
        return id_usuario;
    }

    public void setId_usuario(String id_usuario) {
        this.id_usuario = id_usuario;
    }

    public Date getFecha_alta() {
        return fecha_alta;
    }

    public void setFecha_alta(Date fecha_alta) {
        this.fecha_alta = fecha_alta;
    }

    public Date getFecha_renovacion() {
        return fecha_renovacion;
    }

    public void setFecha_renovacion(Date fecha_renovacion) {
        this.fecha_renovacion = fecha_renovacion;
    }

    public boolean isActivo() {
        return activo;
    }

    public void setActivo(boolean activo) {
        this.activo = activo;
    }

    public String getAgrupacion() {
        return agrupacion;
    }

    public void setAgrupacion(String agrupacion) {
        this.agrupacion = agrupacion;
    }

    public GeoPoint getPosicion() {
        return posicion;
    }

    public void setPosicion(GeoPoint posicion) {
        this.posicion = posicion;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public float getPrice() {
        return price;
    }

    public void setPrice(float price) {
        this.price = price;
    }

    public String getDescripcion() {
        return descripcion;
    }

    public void setDescripcion(String descripcion) {
        this.descripcion = descripcion;
    }

    public void setVisitas(int visitas) {
        this.visitas = visitas;
    }

    public void setFotos(List<Foto> fotos) {
        this.fotos = fotos;
    }

    public int getVisitas() {

        return visitas;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public List<Foto> getFotos() {
        return fotos;
    }

    public void addFoto(Foto foto){
        getFotos().add(foto);
    }

    public int fotoPosition(int position){
        for(int i =0; i<this.getFotos().size();i++){
            Foto foto = this.getFotos().get(i);
            if (foto.getPosition()==position){
                return position;
            }
        }
        return 0;
    }

    public boolean existsFotoPosition(int position){
        for(int i =0; i<this.getFotos().size();i++){
            Foto foto = this.getFotos().get(i);
            if (foto.getPosition()==position){
                return true;
            }
        }
        return false;
    }

    public Foto getFotoByPosition(String position){

        for(int i=0;i<fotos.size();i++){
            Foto foto=fotos.get(i);
            if(String.valueOf(foto.getPosition()).equals(position)){
                return foto;
            }
        }
        return null;
    }

    public Anuncio(Parcel in){
        this.id=in.readString();
        this.id_usuario=in.readString();
        this.fecha_alta=(Date)in.readSerializable();
        this.fecha_renovacion=(Date)in.readSerializable();
        this.activo= in.readByte() !=0;
        this.agrupacion=in.readString();
        this.title = in.readString();
        this.price = in.readFloat();
        this.descripcion = in.readString();
        this.visitas=in.readInt();
        Double lat = in.readDouble();
        Double lng = in.readDouble();
        posicion = new GeoPoint(lat, lng);
        this.address = in.readString();
        in.readTypedList(this.fotos, Foto.CREATOR);
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(this.id);
        dest.writeString(this.id_usuario);
        dest.writeSerializable(fecha_alta);
        dest.writeSerializable(fecha_renovacion);
        dest.writeByte((byte) (activo?1:0));
        dest.writeString(agrupacion);
        dest.writeString(title);
        dest.writeFloat(price);
        dest.writeString(descripcion);
        dest.writeInt(visitas);
        dest.writeDouble(posicion.getLatitude());
        dest.writeDouble(posicion.getLongitude());
        dest.writeString(this.address);
        dest.writeTypedList(this.fotos);
    }

    public static final Creator<Anuncio> CREATOR = new Creator<Anuncio>() {
        public Anuncio createFromParcel(Parcel source) {
            return new Anuncio(source);
        }
        public Anuncio[] newArray(int size) {
            return new Anuncio[size];
        }
    };
}
