package com.example.xavierferraronsserra.sobreruedas.Model;

import android.location.Location;
import android.os.Parcel;
import android.os.Parcelable;

import com.google.android.gms.maps.model.LatLng;
import com.google.firebase.firestore.GeoPoint;

import java.io.Serializable;
import java.util.Date;

/**
 * Created by xavierferraronsserra on 24/4/18.
 */

public class Filter implements Parcelable {

    String description;
    int priceInf;
    int priceSup;
    int distInf;
    int distSup;
    String agrupation;
    Location position;
    boolean active;

    public Filter(){

    }

    public Filter(String description, int priceInf, int priceSup, int distInf, int distSup, String agrupation, Location position, boolean active) {
        this.description = description;
        this.priceInf = priceInf;
        this.priceSup = priceSup;
        this.distInf = distInf;
        this.distSup = distSup;
        this.agrupation = agrupation;
        this.position = position;
        this.active = active;
    }

    public Filter( int priceSup, int distSup){
        this.description="";
        this.priceInf= 0;
        this.priceSup= priceSup;
        this.distInf=0;
        this.distSup=distSup;
        this.agrupation="0";
        this.active = true;
        this.position=new Location("");
        this.position.setLatitude(0);
        this.position.setLongitude(0);
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public int getPriceInf() {
        return priceInf;
    }

    public void setPriceInf(int priceInf) {
        this.priceInf = priceInf;
    }

    public int getPriceSup() {
        return priceSup;
    }

    public void setPriceSup(int priceSup) {
        this.priceSup = priceSup;
    }

    public int getDistInf() {
        return distInf;
    }

    public void setDistInf(int distInf) {
        this.distInf = distInf;
    }

    public int getDistSup() {
        return distSup;
    }

    public void setDistSup(int distSup) {
        this.distSup = distSup;
    }

    public String getAgrupation() {
        return agrupation;
    }

    public void setAgrupation(String agrupation) {
        this.agrupation = agrupation;
    }

    public boolean isActive() {
        return active;
    }

    public void setActive(boolean active) {
        this.active = active;
    }

    public Location getPosition() {
        return position;
    }

    public void setPosition(Location position) {
        this.position = position;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == this) return true;
        if (!(obj instanceof Filter)) {
            return false;
        }

        Filter filter = (Filter) obj;

        if(     filter.description.equals(this.description) &&
                filter.getPriceInf()==this.priceInf &&
                filter.getPriceSup()==this.priceSup &&
                filter.getDistInf()==this.distInf &&
                filter.getDistSup()==this.distSup &&
                filter.agrupation.equals(this.agrupation) &&
                filter.isActive()==this.isActive() ) {
            return true;
        }
        else{
            return false;
        }
    }

    public Filter(Parcel in){
        this.description = in.readString();
        this.priceInf = in.readInt();
        this.priceSup = in.readInt();
        this.distInf = in.readInt();
        this.distSup = in.readInt();
        this.agrupation =  in.readString();
        this.active=in.readByte() != 0;
        Double lat = in.readDouble();
        Double lng = in.readDouble();
        this.position = new Location("");
        this.position.setLatitude(lat);
        this.position.setLongitude(lng);
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(this.description);
        dest.writeInt(this.priceInf);
        dest.writeInt(this.priceSup);
        dest.writeInt(this.distInf);
        dest.writeInt(this.distSup);
        dest.writeString(this.agrupation);
        dest.writeByte((byte) (this.active ? 1 : 0));
        if(position!=null){
            dest.writeDouble(this.position.getLatitude());
            dest.writeDouble(this.position.getLongitude());
        }
        else{
            dest.writeDouble(0);
            dest.writeDouble(0);
        }
    }

    public static final Creator<Filter> CREATOR = new Creator<Filter>() {
        public Filter createFromParcel(Parcel source) {
            return new Filter(source);
        }
        public Filter[] newArray(int size) {
            return new Filter[size];
        }
    };
}
