package com.example.xavierferraronsserra.sobreruedas.Model;

import android.os.Parcel;
import android.os.Parcelable;

import com.google.firebase.firestore.GeoPoint;

import java.util.List;

/**
 * Created by xavierferraronsserra on 5/4/18.
 */

public class Usuario implements Parcelable {

    private String id;
    private String nombre;
    private String apellidos;
    private String email;
    private String telefono;
    private String direccion;
    private GeoPoint posicion;
    private boolean contactoEmail;
    private boolean contactoChat;
    private boolean contactoTelefono;
    private boolean contactoWhatsapp;

    public Usuario()  {
    }

    public Usuario(String id, String nombre, String apellidos, String email, String telefono, String direccion, GeoPoint posicion, boolean contactoEmail, boolean contactoChat, boolean contactoTelefono, boolean contactoWhatsapp, List<Agrupation> agrupaciones, List<Token> tokens) {
        this.id = id;
        this.nombre = nombre;
        this.apellidos = apellidos;
        this.email = email;
        this.telefono = telefono;
        this.direccion = direccion;
        this.posicion = posicion;
        this.contactoEmail = contactoEmail;
        this.contactoChat = contactoChat;
        this.contactoTelefono = contactoTelefono;
        this.contactoWhatsapp = contactoWhatsapp;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }

    public String getApellidos() {
        return apellidos;
    }

    public void setApellidos(String apellidos) {
        this.apellidos = apellidos;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getTelefono() {
        return telefono;
    }

    public void setTelefono(String telefono) {
        this.telefono = telefono;
    }

    public String getDireccion() {
        return direccion;
    }

    public void setDireccion(String direccion) {
        this.direccion = direccion;
    }

    public GeoPoint getPosicion() {
        return posicion;
    }

    public void setPosicion(GeoPoint posicion) {
        this.posicion = posicion;
    }

    public boolean isContactoEmail() {
        return contactoEmail;
    }

    public void setContactoEmail(boolean contactoEmail) {
        this.contactoEmail = contactoEmail;
    }

    public boolean isContactoChat() {
        return contactoChat;
    }

    public void setContactoChat(boolean contactoChat) {
        this.contactoChat = contactoChat;
    }

    public boolean isContactoTelefono() {
        return contactoTelefono;
    }

    public void setContactoTelefono(boolean contactoTelefono) {
        this.contactoTelefono = contactoTelefono;
    }

    public boolean isContactoWhatsapp() {
        return contactoWhatsapp;
    }

    public void setContactoWhatsapp(boolean contactoWhatsapp) {
        this.contactoWhatsapp = contactoWhatsapp;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    public Usuario (Parcel in){
        this.id=in.readString();
        this.nombre= in.readString();
        this.apellidos = in.readString();
        this.email = in.readString();
        this.telefono = in.readString();
        this.direccion = in.readString();
        Double lat = in.readDouble();
        Double lng = in.readDouble();
        this.posicion = new GeoPoint(lat, lng);
        this.contactoEmail = in.readByte() !=0;
        this.contactoChat = in.readByte() !=0;
        this.contactoTelefono = in.readByte() !=0;
        this.contactoWhatsapp = in.readByte() !=0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(this.id);
        dest.writeString(this.nombre);
        dest.writeString(this.apellidos);
        dest.writeString(this.email);
        dest.writeString(this.telefono);
        dest.writeString(this.direccion = direccion);
        dest.writeDouble(posicion.getLatitude());
        dest.writeDouble(posicion.getLongitude());
        dest.writeByte((byte) (this.contactoEmail?1:0));
        dest.writeByte((byte) (this.contactoChat?1:0));
        dest.writeByte((byte) (this.contactoTelefono?1:0));
        dest.writeByte((byte) (this.contactoWhatsapp?1:0));
    }

    public static final Creator<Usuario> CREATOR = new Creator<Usuario>() {
        public Usuario createFromParcel(Parcel source) {
            return new Usuario(source);
        }
        public Usuario[] newArray(int size) {
            return new Usuario[size];
        }
    };
}
