package com.example.xavierferraronsserra.sobreruedas;

import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.example.xavierferraronsserra.sobreruedas.Adapters.NotificacionesAdapter;
import com.example.xavierferraronsserra.sobreruedas.Model.Agrupation;
import com.example.xavierferraronsserra.sobreruedas.Utils.StorageManagement;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.firestore.DocumentSnapshot;
import com.google.firebase.firestore.QuerySnapshot;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * Created by xavierferraronsserra on 16/4/18.
 */

public class NotificacionesFragment extends Fragment {

    private final String TAG= "NotificacionesFragment";
    private FirebaseAuth mAuth;
    private List<Agrupation> mNotifications = new ArrayList<>();
    private NotificacionesAdapter mNotificacionesAdapter;
    @BindView(R.id.notificaciones_recycler_view)
    RecyclerView mRecyclerView;

    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        mAuth = FirebaseAuth.getInstance();
    }

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_notificaciones, container,false);
        ButterKnife.bind(this,view);
        mRecyclerView.setLayoutManager(new LinearLayoutManager(getActivity()));
        updateUI();
        return view;
    }

    @Override
    public void onResume() {
        super.onResume();
    }

    private void updateUI() {
        StorageManagement.getUserNotifications(mAuth.getCurrentUser().getUid())
                .get()
                .addOnCompleteListener(new OnCompleteListener<QuerySnapshot>() {
                    @Override
                    public void onComplete(@NonNull Task<QuerySnapshot> task) {
                        if(task.isSuccessful()){
                            Log.d(TAG, "notifications successfully got!");
                            mNotifications.clear();
                            for (DocumentSnapshot document : task.getResult()) {
                                Agrupation notification = document.toObject(Agrupation.class);
                                mNotifications.add(notification);
                            }
                            mNotificacionesAdapter = new NotificacionesAdapter(getContext(), mNotifications);
                            mRecyclerView.setAdapter(mNotificacionesAdapter);
                        }
                        else{
                            Log.w(TAG, "Error getting notifications");
                        }
                    }
                });
    }


}
