package com.example.xavierferraronsserra.sobreruedas.Utils;

import android.app.AlertDialog;
import android.content.Context;

import com.example.xavierferraronsserra.sobreruedas.Model.Anuncio;
import com.example.xavierferraronsserra.sobreruedas.Model.Foto;
import com.example.xavierferraronsserra.sobreruedas.R;
import com.google.firebase.firestore.GeoPoint;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * Created by xavierferraronsserra on 5/4/18.
 */

public class Utils {

    public Utils() {
    }
        public static String formatPrice(Float price){
            DecimalFormat f = new DecimalFormat("###,###.###");
            return f.format(price)+ " €";
        }

    public static String FloatToStringPrice(Float price){
        DecimalFormat f = new DecimalFormat("###,###.###");
        return f.format(price);
    }

    public static String formatPrice(int price){
        DecimalFormat f = new DecimalFormat("###,###");
        return f.format(price)+ " € ";
    }

    public static String formatDistance(int price){
        DecimalFormat f = new DecimalFormat("###,###");
        return f.format(price)+ " Km ";
    }

    public static String formatDate(Date date){
        SimpleDateFormat f = new SimpleDateFormat("dd-MM-yyyy");
        return f.format(date);
    }

    public static JSONObject ObjectToJsonAnuncio(Anuncio anuncio){

        JSONObject jsonAnuncio = new JSONObject();
        JSONArray fotos = new JSONArray();

        for(Foto foto: anuncio.getFotos()) {

            try {
                fotos.put(new JSONObject()
                        .put("url", foto.getUrl())
                        .put("position", foto.getPosition()));

            } catch (JSONException e) {
                e.printStackTrace();
            }
        }

        try {
            jsonAnuncio
                    .put("objectID", anuncio.getId())
                    .put("id_usuario", anuncio.getId_usuario())
                    .put("activo", anuncio.isActivo())
                    .put("agrupacion", anuncio.getAgrupacion())
                    .put("visitas", anuncio.getVisitas())
                    .put("title", anuncio.getTitle())
                    .put("price", anuncio.getPrice())
                    .put("descripcion", anuncio.getDescripcion())
                    .put("fecha_alta", anuncio.getFecha_alta().getTime() / 1000)
                    .put("fecha_renovacion", anuncio.getFecha_renovacion().getTime() / 1000)
                    .put("_geoloc", new JSONObject().put("lat", anuncio.getPosicion().getLatitude()).put("lng", anuncio.getPosicion().getLongitude()))
                    .put("address",anuncio.getAddress())
                    .put("fotos",fotos);

        } catch (JSONException e) {
            e.printStackTrace();
        }

        return jsonAnuncio;
    }

    public static Anuncio jsonToObjectAnuncio(JSONObject jsonAnuncio){
        if(jsonAnuncio==null)
            return null;

        String id =jsonAnuncio.optString("objectID");
        String id_usuario= jsonAnuncio.optString("id_usuario");
        Date fecha_alta = new Date();
        Long mils_alta = jsonAnuncio.optLong("fecha_alta")*1000;
        fecha_alta= new Date(mils_alta);

        Date fecha_renovacion = new Date();
        Long mils_renovacion = jsonAnuncio.optLong("fecha_renovacion")*1000;
        fecha_renovacion= new Date(mils_renovacion);

        boolean activo = jsonAnuncio.optBoolean("activo");
        String agrupacion = jsonAnuncio.optString("agrupacion");

        JSONObject _geoloc = jsonAnuncio.optJSONObject("_geoloc");
        Double lat = _geoloc.optDouble("lat");
        Double lng = _geoloc.optDouble("lng");
        GeoPoint posicion = new GeoPoint(lat, lng);

        String title = jsonAnuncio.optString("title");
        float price = (float)  jsonAnuncio.optDouble("price");
        String descripcion = jsonAnuncio.optString("descripcion");
        int visitas = jsonAnuncio.optInt("visitas");
        String address = jsonAnuncio.optString("address");

        JSONArray jsonFotos = jsonAnuncio.optJSONArray("fotos");
        List<Foto> fotos = new ArrayList<>();

        if(jsonFotos!=null) {
            for (int i = 0; i < jsonFotos.length(); i++) {
                JSONObject jsonFoto = jsonFotos.optJSONObject(i);
                Foto foto = new Foto(jsonFoto.optString("url"), jsonFoto.optInt("position"));
                fotos.add(foto);
            }
        }

        return new Anuncio(id, id_usuario, fecha_alta, fecha_renovacion,activo,agrupacion,posicion,title,price,descripcion,visitas,address,fotos);
    }

    public static ArrayList<Anuncio> jsonToObjectAnuncios(JSONObject jsonAnuncios){

        if (jsonAnuncios == null)
            return null;
        ArrayList<Anuncio> results = new ArrayList<>();
        JSONArray hits = jsonAnuncios.optJSONArray("hits");
        if (hits == null)
            return null;
        for (int i = 0; i < hits.length(); ++i) {
            JSONObject hit = hits.optJSONObject(i);
            if (hit == null)
                continue;
            Anuncio anuncio = Utils.jsonToObjectAnuncio(hit);
            if (anuncio == null)
                continue;
            results.add(anuncio);
        }
        return results;
    }

    public static int tryParseInt(String value) {
        try {
            return Integer.parseInt(value);
        } catch(NumberFormatException nfe) {
            // Log exception.
            return 0;
        }
    }

    public static AlertDialog.Builder alertDialogLogged(Context ctx, String text) {
        AlertDialog.Builder builder = new AlertDialog.Builder(ctx);
        builder.setMessage(text);
        builder.setPositiveButton("OK", null);
        builder.show();
        return builder;

    }
}
